;EasyCodeName=WebCam,1
.Const

WM_CAP_DRIVER_CONNECT		Equ	WM_USER + 10
WM_CAP_DRIVER_DISCONNECT	Equ	WM_USER + 11
WM_CAP_FILE_SAVEDIB			Equ	WM_USER + 25
WM_CAP_SET_PREVIEW			Equ	WM_USER + 50
WM_CAP_SET_PREVIEWRATE		Equ	WM_USER + 52
WM_CAP_SET_SCALE			Equ	WM_USER + 53


.Data?

hInstance		DD	?
hWebcam			DD	?

.Data

_camtitle		DB	'EASYCODEWEBCAM', 0
_filename  		DB	'IMAGE.BMP'	; Filename
nDevice			DD	0			; Device Number -> It can range from 0 through 9
nFPS	     	DD	100			; Frames per second. Must be 1000/FPS. E.g. 20 FPS = 50


.Code

start:
	Invoke  GetModuleHandle, 0
	Mov [hInstance], Eax
	Invoke  DialogBoxParam, Eax, IDD_MAIN, HWND_DESKTOP, Addr MainDlg, 0
	Invoke  ExitProcess, 0

MainDlg Proc Uses Ebx Esi Edi hdlg, msg, wparam, lparam
	Cmp msg, WM_INITDIALOG
	Je wminitdlg
	Cmp msg, WM_COMMAND
	Je wmcommand
	Cmp msg, WM_CLOSE
	Je wmclose
	Xor Eax, Eax
	Ret

wminitdlg:
	Invoke  capCreateCaptureWindow, Addr _camtitle, (WS_VISIBLE Or WS_CHILD), 10, 10,
									266, 252, hdlg, 0
	Mov hWebcam, Eax
	Return TRUE

wmcommand:
	HiWord wparam
	Cmp Ax, BN_CLICKED
	Jne @F
	LoWord wparam
	Cmp Ax, IDC_START
	Je startbutton
	Cmp Ax, IDC_STOP
	Je stopbutton
	Cmp Ax, IDC_CLICK
	Je clickbutton
@@:	Xor Eax, Eax
	Ret

wmclose:
	Invoke  SendMessage, hWebcam, WM_CAP_DRIVER_DISCONNECT, Addr _camtitle, 0
	Invoke  EndDialog, hdlg, 0
	Ret

startbutton:
	Invoke  SendMessage, hWebcam, WM_CAP_DRIVER_CONNECT, nDevice, 0
	Invoke  SendMessage, hWebcam, WM_CAP_SET_SCALE, TRUE, 0
	Invoke  SendMessage, hWebcam, WM_CAP_SET_PREVIEWRATE, nFPS, 0
	Invoke  SendMessage, hWebcam, WM_CAP_SET_PREVIEW, TRUE, 0
	Ret

stopbutton:
	Invoke  SendMessage, hWebcam, WM_CAP_DRIVER_DISCONNECT, Addr _camtitle, 0
	Ret

clickbutton:
	Invoke  SendMessage, hWebcam, WM_CAP_FILE_SAVEDIB, 0, Addr _filename
	Ret
MainDlg EndP

End start
